if not IsTrialAccount() then --check for paid account
	local enabled = 1
	local fishing = nil
	local formingRaid = nil
	local f3piGroup = nil
	local askers = {}
	local passLeadTo

	local f = CreateFrame("frame")

	f:RegisterEvent("CHAT_MSG_WHISPER")
	f:RegisterEvent("GROUP_ROSTER_UPDATE")
    f:RegisterEvent("CHAT_MSG_ADDON")
    
	DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FF" .. F3PLoc.i["F3PI_LOADED"] .. "|r")

	local function F3PI_FilterOutgoing(self, event, ...)
		local msg = ...
		if msg:match("%[F3PI%]") then
			return true
		else
			return false
		end
	end

	local function F3PI_FilterIncoming(self, event, ...)
		local msg = ...
		if msg:match("^inv$") or msg:match("^lead$") or msg:match("^close$") or msg:match("%[F3PI%]") then
			return true
		else
			return false
		end
	end

	ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER_INFORM", F3PI_FilterOutgoing)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY", F3PI_FilterOutgoing)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", F3PI_FilterIncoming)

	f:SetScript("OnEvent", function(self, event, ...)
		if event == ("CHAT_MSG_WHISPER") then
			--[[]]if F3PAddon_Variables.Settings.Verbose then print("event happened - CHAT_MSG_WHISPER") end
			local msg, sender, _, _, _, flags = ...
			if not (flags == "GM") or (not IsInGuild(sender)) then
				if (not F3PChat_IsBlocked(sender)) then
					if (enabled) then
			
						--find out if you are either queued for BGs or LFD, are in a BG/dungeon after queueing, or are in a world PvP zone.
						local busy = false
						
						local lmode
						for m = 1, 4 do
							lmode = GetLFGMode(m)
							if lmode then
								busy = true
							end
						end
						
						for x = 1, GetMaxBattlefieldID() do
							if GetBattlefieldStatus(x) ~= "none" then
								busy = true
							end
						end
						local zone = GetRealZoneText()
						if ( zone == F3PLoc.i["TOL_BARAD"] ) or ( zone == F3PLoc.i["WINTERGRASP"] ) then
							busy = true
						end
						if not msg:match("\[F3PI\]") then --stop the addons getting into a loop of messaging each other
							-- if 'inv' was in the message, but was not it's only content; or the words 'group' or 'party' were used, indicating that the sender might have asked for a group.
							if ((msg:lower():match("inv")) and (not msg:lower():match("^inv$"))) or (msg:lower():match("group")) or (msg:lower():match("party")) then
								SendChatMessage(F3PLoc.i["CLARIFY_COMMAND"], "WHISPER", nil, sender)

							-- specific 'inv' command received
							elseif msg:lower():match("^inv$") then
								--if not using BG/LFD, not yet in a party, or is leader of a party
								if (not busy) and ((not UnitExists("party1")) or UnitIsGroupLeader("player")) then
									--switch over to a raid to make space for additional members if we're at the party size limit
									if (GetNumGroupMembers() == 5) and (not IsInRaid()) then
										ConvertToRaid()
									end
									tinsert(askers, sender)
									InviteUnit(sender)
									if (not fishing) then
										SendChatMessage(F3PLoc.i["ACCEPTED_COMMANDS_1"], "WHISPER",nil, sender)
										SendChatMessage(F3PLoc.i["ACCEPTED_COMMANDS_2"], "WHISPER", nil, sender)
										SendChatMessage(F3PLoc.i["ACCEPTED_COMMANDS_3"], "WHISPER", nil, sender)
									elseif (fishing) then
										SendChatMessage(F3PLoc.i["FISHING_COMP_MODE"], "WHISPER", nil, sender)
									end
								elseif ( busy or (UnitExists("party1") and not UnitIsGroupLeader("player")) ) then
									SendChatMessage(F3PLoc.i["BUSY_RESPONSE"], "WHISPER", nil, sender)
								end
	
							--'lead' command received
							elseif msg:lower():match("^lead$") and (not fishing) and UnitInParty(sender) then
								if (not busy) and UnitExists("party1") and UnitIsGroupLeader("player") and UnitInParty(sender) then
									passLeadTo = sender
									SendChatMessage(string.format(F3PLoc.i["LEADER"], sender), "PARTY", nil, sender)
								elseif (not busy) and not (UnitExists("party1") or UnitInParty(sender)) then
									SendChatMessage(F3PLoc.i["NOT_LEADING"], "WHISPER", nil, sender)
								end
							
							--'close' command received
							elseif msg:lower():match("^close$") and (not fishing) and UnitInParty(sender) then
								F3PI_CloseGroup(passLeadTo)
                            end
						end
					elseif (not enabled) and (not msg:match("\[F3PI\]")) and ( (msg:lower():match("inv")) )  then
						SendChatMessage(F3PLoc.i["AUTO_DISABLED"], "WHISPER", nil, sender)
					end
				else
					SendChatMessage(F3PLoc.i["LEVEL_LIMIT"], "WHISPER", nil, sender)
				end
			end
		
		elseif event == ("GROUP_ROSTER_UPDATE") and (enabled) then
			--[[]]if F3PAddon_Variables.Settings.Verbose then print("event happened - GROUP_ROSTER_UPDATE") end
			--if we have reached the party limit, and no-one has asked for a raid sized group, pass lead and leave the group
			if (f3piGroup == 1) and (GetNumGroupMembers() == 6) and (not fishing) then
				F3PI_CloseGroup(passLeadTo)
			
			--if anyone asked for a group
			elseif #askers > 0 then
				--[[]]if F3PAddon_Variables.Settings.Verbose then print("someone asked for a group") end
				--check if the person who joined is one of them
				for x = 1, #askers do
					if UnitInParty(askers[x]) then
						--[[]]if F3PAddon_Variables.Settings.Verbose then print("found "..tostring(askers[x]).." in party, setting f3piGroup to 1") end
						f3piGroup = 1  --mark this as an F3PI formed group if so
					end
				end
			
				--if it is...
				if f3piGroup then
					--and they're the first to join...
					if (GetNumGroupMembers() == 2) then
						passLeadTo = UnitName("party1")  --will be passing lead to them when the group closes
						--[[]]if F3PAddon_Variables.Settings.Verbose then print("passLeadTo = "..tostring(passLeadTo)) end
						--[[]]if F3PAddon_Variables.Settings.Verbose then print("party1 = "..tostring(UnitName("party1"))) end

					end
				end

			--if you're no longer in a party, reset the function's flags
			elseif (not UnitExists("party1")) then
				fishing = nil
				formingRaid = nil
				f3piGroup = nil
				askers = {}
				passLeadTo = nil
			end
            
        elseif (event == "CHAT_MSG_ADDON") then
            local a,b,c,d,e,f,g,h,i,j,k = ...
            local prefix, msg, channel, sender = a, b, c, d
            if (prefix == F3PAddonGlobalVars.AddonChannel1Name)  and (channel == "WHISPER") and (enabled) then
                if msg:lower():match("^p2p%?$") and (not fishing) then
                    F3PChat_RouteChatMessage(F3PLoc.i["CAN_GROUP"])            
                end
            end
		end
	end	
	)

	function F3PI_CloseGroup(newLead)
		if (GetNumGroupMembers() == 6) then
			SendChatMessage(F3PLoc.i["QUEUEING_AS_RAID"], "RAID", nil)
		end
		local partyList = {}
		if UnitInRaid("player") then
			for x = 1, GetNumGroupMembers() do
				local y = GetRaidRosterInfo(x)
				if y ~= UnitName("player") then
					if y == newLead then
						y = y.." (leader)"
					end
					tinsert(partyList, y)
				end
			end
		elseif not UnitInRaid("player") then
			for x = 1, GetNumGroupMembers() do
				local y = UnitName("party"..x)
				if y ~= UnitName("player") then
					if y == newLead then
						y = y.." (leader)"
					end
					tinsert(partyList, y)
				end
			end
		end
		local msg = F3PLoc.i["GROUP_FORMED"] .. table.concat(partyList, ", ")
		F3PChat_RouteChatMessage(msg)  --send via addon
		F3PChat_FormatIncoming(msg, F3PAddonGlobalVars.myName) --print sent message
		PromoteToLeader(newLead, 1)
		LeaveParty()
	end

	local commandTable = {  --create the data structure that the slash commands work from
		["fish"] = function()	
			if fishing == 1 then
				fishing = nil
				print(F3PLoc.i["FISHING_MODE_DISABLED"])
			else
				fishing = 1
				print(F3PLoc.i["FISHING_MODE_ENABLED"])
			end
		end,
		["default"] = function()
			if enabled == 1 then
				enabled = nil
				--[[]]if F3PAddon_Variables.Settings.Verbose then print("[F3PI] disabled") end
				local msg = F3PLoc.i["MANUALLY_DISABLED"]
				F3PChat_RouteChatMessage(msg)  --send via addon
				F3PChat_FormatIncoming(msg, F3PAddonGlobalVars.myName) --print sent message
			else
				enabled = 1
				--[[]]if F3PAddon_Variables.Settings.Verbose then print("[F3PI] enabled") end
				local msg = F3PLoc.i["MANUALLY_ENABLED"]
				F3PChat_RouteChatMessage(msg)  --send via addon
				F3PChat_FormatIncoming(msg, F3PAddonGlobalVars.myName) --print sent message
			end
		end,
	}

	local function runSlashCommand(message, cmdTable)
		local command, parameters = string.split(" ", message, 2)
		if (command == nil) or (command == "") then
			commandTable.default()
		elseif command == "fish" then
			commandTable.fish()
		end
	end

	SLASH_F3PI1 = "/f3pi"
	SlashCmdList["F3PI"] = function(txt)
		runSlashCommand(txt, commandTable)
	end

else --for trials
	DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FF" .. F3PLoc.i["ON_TRIAL"] .. "|r")
end
