

--  /f3pi slash commands are handled in f3pinvite.lua, as it still functions like a separate addon.


local commandTableA = {
	["channel"] = function(parameters)	
		LeaveChannelByName(F3PAddonGlobalVars.Channel1Name)
		F3PAddon_Variables.Realms[F3PAddonGlobalVars.thisRealm][F3PAddonGlobalVars.myFaction]["Settings"]["Channel"] = parameters
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FF" .. string.format(F3PLoc.slash["CHANNEL_CHANGED"], parameters))
		ReloadUI()
	end,
	["default"] = function()
		InterfaceOptionsFrame_OpenToCategory("F3PAddon")
	end,
}

local function runSlashCommandA(message, cmdTable)
	local command, parameters = string.split(" ", message, 2)
	if (command == nil) or (command == "") then
		commandTableA.default()
	elseif (command == "channel") then
		commandTableA.channel(parameters)
	end
end


SLASH_F3PADDON1 = "/f3paddon"
SlashCmdList["F3PADDON"] = function(txt)
	runSlashCommandA(txt, commandTableA)
end





local commandTableQ = {
	["reset"] = function()	
		F3PAddonGlobalVars.queueData = {}
		F3PQ_TableToDisplay()
	end,
	["default"] = function()
		if not PVPUIFrame then
            LoadAddOn("Blizzard_PVPUI")
        end
        if not F3PAddonQueueInfoFrame:IsVisible() and not PVPUIFrame:IsVisible() then
            if F3PAddonGlobalVars.f3pq_docked == true then
                F3PAddonQueueInfoFrame:SetPoint("TOPLEFT", PVPUIFrame, "TOPRIGHT")
			    F3PAddonQueueInfoFrame:SetPoint("BOTTOMRIGHT", PVPUIFrame, "TOPRIGHT", 280, -290)
			    F3PAddonQueueInfoFrame:SetPoint("BOTTOMLEFT", PVPUIFrame, "TOPRIGHT", 0, -290)
			    F3PAddonQueueInfoFrame:SetPoint("TOPRIGHT", PVPUIFrame, "TOPRIGHT", 280, 0)
            end
            F3PAddonQueueInfoFrame:Show()
            F3PQ_TableToDisplay()
            PVPUIFrame_ToggleFrame()
        elseif F3PAddonQueueInfoFrame:IsVisible() and PVPUIFrame:IsVisible() then
				PVPUIFrame_ToggleFrame()
		elseif F3PAddonQueueInfoFrame:IsVisible() and not PVPUIFrame:IsVisible() then
                F3PAddonQueueInfoFrame:Hide()		
		elseif not F3PAddonQueueInfoFrame:IsVisible() and PVPUIFrame:IsVisible() then
			F3PAddonQueueInfoFrame:Show()		
			F3PQ_TableToDisplay()
		end
	end,
}

local function runSlashCommandQ(message, cmdTable)
	local command, parameters = string.split(" ", message, 2)
	if (command == nil) or (command == "") then
		commandTableQ.default()
	elseif command == "reset" then
		commandTableQ.reset()
	end
end



SLASH_F3PQ1 = "/f3pq"
SlashCmdList["F3PQ"] = function(txt)
	runSlashCommandQ(txt, commandTableQ)
end
